define(["dojo/_base/declare",
        "dojo/_base/lang",
        "dijit/_Widget",
        "dojo/string",
        "dojo/dom-style",
        "dijit/form/RadioButton",
        "dojox/form/Uploader",
        "dojox/form/uploader/plugins/IFrame",
        "idx/form/TextBox",
        "idx/form/RadioButtonSet"
        ],
        function(dDeclare,
                dLang,
                dWidget,
                //dTemplatedMixin,
                //dWidgetsInTemplateMixin,
                templateText,
                dString,
                domStyle) {
return dDeclare("admin.users.dialogs.ImportUserWizardController", [],  
{
	
    importTypePage: null,
    
    ldapInfoPage: null,
     
    ldapFilterPage: null,
     
    resultPage: null,
    
    /**
     * Handle to the wizard
     */
    wizard: null,
    
    /**
     * Existing ldap information
     */
    ldapInfo: null,
    
    /**
     * Set the wizard for this controller
     */
    setWizard:function(wizard) {
    	this.wizard = wizard;
    	if (this.importTypePage != null) {
    		this.importTypePage.controller = this;
    	}
    	if (this.ldapInfoPage != null) {
    		this.ldapInfoPage.controller = this;
    	}
    	if (this.ldapFilterPage != null) {
    		this.ldapFilterPage.controller = this;
    	}
    	if (this.resultPage != null) {
    		this.resultPage.controller = this;
    	}
    },
    
    /**
     * Get the next page
     */
    getNextPage:function(currentPage) {
        if (currentPage == this.importTypePage) {
            console.log("import type: " + this.importTypePage.getImportType());
            if (this.importTypePage.getImportType() == "file") {
                return this.resultPage;
            }
            else {
                return this.ldapInfoPage;
            }
        }
        else if (currentPage == this.ldapInfoPage) {
            return this.ldapFilterPage;
        }
        else if (currentPage == this.ldapFilterPage) {
            return this.resultPage;
        }
        return null;
    },
    
    /**
     * Get the previous page
     */
    getPreviousPage:function(currentPage) {
    	if (currentPage == this.resultPage) {
    		if (this.importTypePage.getImportType() == "file") {
    			return this.importTypePage;
    		}
    		else {
    			return this.ldapFilterPage;
    		}
    	}
    	else if (currentPage == this.ldapFilterPage) {
    		return this.ldapInfoPage;
    	}
    	else if (currentPage == this.ldapInfoPage) {
    		return this.importTypePage;
    	}
    	return null;
    },
    
    /**
     * Update the wizard controls
     */
    updateWizardButtonStates:function() {
    	console.log("updateWizardButtonStates");
    	if (this.wizard != null) {
    		this.wizard._checkButtons();
    	}
    },
    
    /**
     * Get the first page
     */
    getFirstPage:function() {
        return this.importTypePage;
    },
    
    /**
     * Check if the wizard can finish
     */
    canFinish:function() {
    	if (this.wizard.getCurrentPage() == this.resultPage && this.resultPage.isComplete()) {
    		return true;
    	}
    	return false;
    },
    
    /**
     * Get the list of external users that has been uploaded
     */
    getExternalUserList:function() {
        if (this.importTypePage.getImportType() == "file") {
            return this.importTypePage.uploadContent;
        }
        return null;
    },

    /**
     * Get the ldap filter from this wizard
     */
    getLDAPFilters:function() {
    	if (this.importTypePage.getImportType() == "file") {
    		return null;
    	}
    	else {
    		return this.ldapFilterPage.getLDAPFilters();
    	}
    },
    
    /**
     * Get the ldap server info
     */
    getLDAPInfo:function() {
    	if (this.importTypePage.getImportType() == "file") {
    		return null;
    	}
    	else {
    		return this.ldapInfoPage.getLDAPInfo();
    	}
    }
    
});
	
});
